#!/bin/sh

. ./base-config.sh

STREAM=1

TIME=$(echo $QUERY_STRING | cut -d"=" -f2 | cut -c1,2,5,6,7 | tr "A" ":")
NOW=$(date +%s)
SECONDS=$(date -d $TIME +%s)

if [ $SECONDS -lt $NOW ] ; then        # if time is in the past...
  EPGTIME=$(($SECONDS+24*60*60))       # ... add 24 hours
else
  EPGTIME=$SECONDS
fi

echo $CT
echo ""

/bin/cat << EOM
<html>
<head>
<title>EPG</title>
<link rel="stylesheet" media="screen" type="text/css" href="/screen.css">
<link rel="stylesheet" media="handheld" type="text/css" href="/handheld.css">
</head>

<form name="form1" method="GET" action="epg_at.sh">
<table class="epgframe">
EOM

. ./base-menu.sh

/bin/cat << EOM
  <tr>
    <td>
      <table class="epgtable">
      <tr>
        <td class="epghleft">
EOM

echo $(date +%H:%M)
echo "</td>"
echo "<td colspan=2 class=\"epghright\">$XRUNNING: <a href=\"/cgi-bin/epg_now.sh\">$XNOW</a> | <a href=\"/cgi-bin/epg_next.sh\">$XNEXT</a> | $XAT <input type=text name=value size=4 value=\""
echo $TIME
echo "\"></td>"

/bin/cat << EOM
      </tr>
      </table>
    </td>
  </tr>

EOM

if [ -e /tmp/pda ] ; then
  ./base-lsvdr -l $LANG -t at $EPGTIME -m $MAXCHANNELS epg | grep -v "epgsubtitle" | grep -v "epgdesc"
else
	if [ -e /opt/iepg ] ; then
		./base-lsvdr -l $LANG -t at $EPGTIME -m $MAXCHANNELS epg |sed -e 's/|/<br>/g'|sed -e 's/\(Picture=\/opt\)\(\/.*png\)/<br><img src="\2"\/>/g'|sed -e 's/\(Top Tipp: Tagestipp\)/<b><font color=red>\1<\/font><\/b>/g'|sed -e 's/\(Top Tipp: Tipp\)/<font color=red>\1<\/font>/g'
	else
	  ./base-lsvdr -l $LANG -t at $EPGTIME -m $MAXCHANNELS epg
	fi
fi

/bin/cat << EOM
</table>
</body>
</html>
EOM



