#!/bin/sh

# in german because tvinfo is a german service

cd /etc/reelhttp-base/cgi-bin/

. ./base-config.sh

if [ ! -e tvinfo-channelmap ] ; then
  cp tvinfo-template-channelmap tvinfo-channelmap
fi


if [ ! -e channel_map ] ; then
  ./base-lsvdr -l ge -m $MAXCHANNELS channels > /dev/null
fi

TVINFOMERK=/tmp/tvinfo-import
TVINFOLOG=/tmp/tvinfolog

if [ -e $TVINFOLOG ] ; then
	rm $TVINFOLOG
fi

MD5PASS=$(echo -n $TVINFOPASS | md5sum | cut -d" " -f1)

CMD=$(echo wget -O $TVINFOMERK "http://www.tvinfo.de/share/openepg/schedule.php?username=$TVINFONAME&password=$MD5PASS")

echo "> Datum: $(date)" | tee -a $TVINFOLOG

if [ -e $TVINFOMERK ] ; then
  rm $TVINFOMERK
fi
echo "> hole tvinfo - merklist... "  | tee -a $TVINFOLOG
$CMD  | tee -a $TVINFOLOG
echo ""  | tee -a $TVINFOLOG

STANDBY=0
ITEMS=0

if [ -e $TVINFOMERK ] ; then

    for i in $(cat $TVINFOMERK | tr -s " " "_" | sed s/"<epg_schedule_entry"/" "/g)
    do
echo "aktuelle Zeile:"
echo $i
echo "------"
    	if [ $(echo $i | grep "_uid=") ] ; then

        ITEMS=1

       # alte images
        if [ -e /tmp/vdr.shutdown ] ; then
          echo "> Eintrge vorhanden, wecke VDR, warte 2min"  | tee -a $TVINFOLOG
          rm /tmp/vdr.shutdown
          STANDBY=1
          sleep 2m
          echo "> werte Eintrge aus ..." | tee -a $TVINFOLOG
        fi

      # neue images
        if [ -e /tmp/vdr.standby ] ; then
          echo "> Eintrge vorhanden, wecke VDR, warte 2min" | tee -a $TVINFOLOG
          rm /tmp/vdr.standby
          STANDBY=1
          sleep 2m
          echo "> werte Eintrge aus ..." | tee -a $TVINFOLOG
        fi

 #   		echo "> Eintrag tvinfo erste Zeile:" | tee -a $TVINFOLOG
 #       echo "$(echo $i | tr -s '<' '+' | tr -s '>' '+')" | tee -a $TVINFOLOG

		#i=$(echo $i | cut -d"=" -f4-)
		
    		channelname=$(echo $i | cut -d"=" -f3 | cut -d\" -f2)
#echo "Kanal:" $channelname
    		for j in $(cat tvinfo-channelmap | tr -s " " "_" | grep $channelname )
    		do
    		    tmp_j=$(echo $j | cut -d"=" -f1)
    		    if [ $channelname = $tmp_j ] ; then
    		        REELNAME=$(echo $j | cut -d"=" -f2)
    		    fi
        done

        CHANNELNUMBER=0

        if [ $(cat channel_map | tr -s " " "_" | grep -c $REELNAME) -gt 0 ] ; then
            if [ $(cat channel_map | tr -s " " "_" | grep -c $REELNAME) -gt 1 ] ; then
                for j in $(cat channel_map | tr -s " " "_" | grep $REELNAME)
            		do
            		    REELCHANNELNAME=$(echo $j | cut -d":" -f2)
            		    echo "<p><i>$REELNAME ?= $REELCHANNELNAME</i>"
                    if [ $REELNAME = $REELCHANNELNAME ] ; then
                        echo "<p>->$j</p>"
            		        CHANNELNUMBER=$(echo $j | cut -d":" -f1)
            		    fi
                done
            else
                CHANNELNUMBER=$(cat channel_map | tr -s " " "_" | grep $REELNAME | cut -d":" -f1)

            fi
        fi

        channumber=$CHANNELNUMBER

    	start=$(echo $i | cut -d"=" -f4 | cut -d\" -f2)
    	day=$(echo $start | cut -d"_" -f1)
    	stime=$(echo $start | cut -d"_" -f2 | cut -d":" -f1,2)
    	etime=$(echo $i | cut -d"=" -f5 | cut -d"_" -f2 | cut -d":" -f1,2)

        MARGINSTART=$(cat $VDRCONF/setup.conf | grep "^MarginStart =" | cut -d" " -f3)
        MARGINSTOP=$(cat $VDRCONF/setup.conf | grep "^MarginStop =" | cut -d" " -f3)

      	if [ $REEL -eq 1 ] ; then
	        startstring=$(echo $day $stime)
	        endstring=$(echo  $etime)
	      else
	        year=$(echo $day | cut -d"-" -f1)
          month=$(echo $day | cut -d"-" -f2)
          tday=$(echo $day | cut -d"-" -f3)
          start_hour=$(echo $stime | cut -d":" -f1)
	        start_min=$(echo $stime | cut -d":" -f2)
          startstring=$(echo $month$tday$start_hour$start_min$year)
        	endstring=$(echo $etime)
        fi

        stimesec=$(date -d "$startstring" +%s)
      	etimesec=$(date -d "$endstring" +%s)

	      stimesec=$(($stimesec - $(($MARGINSTART*60))))
        etimesec=$(($etimesec + $(($MARGINSTOP*60))))

	       if [ $REEL -eq 1 ] ; then
		        start=$(date -d@$stimesec "+%Y-%m-%d:%H%M")
		        end=$(date -d@$etimesec "+%H%M")
	       else
	          start=$(echo -n $stimesec | awk '{ print strftime("%Y-%m-%d:%H%M", $0) }')
	          end=$(echo -n $etimesec | awk '{ print strftime("%H%M", $0) }')
         fi

    	fi

    	if [ $(echo $i | grep "<title>") ] ; then

    		title=$(echo $i | cut -d">" -f3 | cut -d"<" -f1)

    		svdrcommand=$(echo "updt 1:$channumber:$start:$end:60:60:$TVINFOPREFIX$title")
#debug
#channumber=7
        if [ $channumber -gt 0 ] ; then
      		  echo "> Timereintrag:" | tee -a $TVINFOLOG
            echo "$REELNAME: $channumber $day $stime $etime $title" | tee -a $TVINFOLOG
          echo "<p><b>svdrcommand:</b> $svdrcommand"
		        echo "> Absenden an VDR: " | tee -a $TVINFOLOG
#debug
		        #MSG=$(echo $svdrcommand)
		        MSG=$(/sbin/svdrpsend.sh $svdrcommand | grep 250)
		        if [ $? -eq 0 ] ; then
		        	echo "----OK----> $MSG" | tee -a $TVINFOLOG
		        else

		        	/sbin/svdrpsend.sh $svdrcommand | tee -a $TVINFOLOG
		        fi
		    else
          echo "####FEHLER####> : Kanal -$channelname- nicht gefunden ? - bitte /etc/reelhttp-base/cgi-bin/tvinfo-channelmap pruefen!" | tee -a $TVINFOLOG
          #echo "$svdrcommand"
        fi
        echo ""
    	fi

     	if [ $(echo $i | grep "error") ] ; then
     	  echo "######### Fehlermeldung durch tvinfo: #############" | tee -a $TVINFOLOG
     	  cat $TVINFOMERK  | tee -a $TVINFOLOG
     	fi


    done

#    rm $TVINFOMERK


    if [ $STANDBY -eq 1 ] ; then
      /sbin/svdrpsend.sh "hitk power"
    fi

    if [ $ITEMS -eq 0 ] ; then
      echo "---- keine Eintraege auf Merkzettel ----" | tee -a $TVINFOLOG
    fi

else
	echo "no $TVINFOMERK" | tee -a $TVINFOLOG
fi

echo "---- fertig! ----" | tee -a $TVINFOLOG
